#!/bin/bash

if [ "$BSP_ROOT" == "" ]; then
	echo "Please set BSP_ROOT!"
	exit 1
fi

cd ..

CURDIR=`pwd`


export TOOLCHAIN_DIR=$BSP_ROOT/vendor/mediatek/c4a/prebuilts/c4a/toolchain
export CLANG=$TOOLCHAIN_DIR/armv7a/usr/bin/clang
export PATH=$TOOLCHAIN_DIR/armv7a/bin:$PATH

export CROSS_COMPILE=armv7a-cros-linux-gnueabi-

export CC=${CROSS_COMPILE}clang
export CXX=${CROSS_COMPILE}clang++
export AR=${CROSS_COMPILE}ar
#export RANLIB=${CROSS_COMPILE}ranlib
export LINK=${CXX}

export CCFLAGS='-mcpu=cortex-a7 -mtune=cortex-a7 -mfpu=neon-vfpv4 -mthumb-interwork -mthumb'
export CXXFLAGS='-mcpu=cortex-a7 -mtune=cortex-a7 -mfpu=neon-vfpv4 -mthumb-interwork -mthumb'

INSTALLDIR=$CURDIR/../prebuilt

########### function #######################
config() {
    ./configure --host=armv7a-cros-linux-gnueabi --prefix=/mt8590/release --disable-debug-mode
}

install() {
    if [ -e Makefile ]; then
        make install -j4 DESTDIR=$INSTALLDIR
    fi
}

uninstall() {
    if [ -e Makefile ]; then
        make uninstall -j4 DESTDIR=$INSTALLDIR
    fi
}

clean() {
    if [ -e Makefile ]; then
        make clean
    fi
}

distclean() {
    if [ -e Makefile ]; then
        make distclean
    fi
}

all() {
    if [ ! -e Makefile ]; then
        config
    fi
    if [ -e Makefile ]; then
        make -j4
    fi
}

########### command dispatch ###############
if [ $# -eq 1 ]; then
    if [ $1 = "install" ]; then
        install
    elif [ $1 = "uninstall" ]; then
        uninstall
    elif [ $1 = "clean" ]; then
        clean
    elif [ $1 = "distclean" ]; then
        uninstall
        distclean
    elif [ $1 = "all" ]; then
        all
    else
        echo "ERROR! : command [build install/uninstall/clean/distclean/all]"
    fi
else
    all
    install
fi
